#!/usr/local/bin/perl

$listaddr = '@list.stairways.com';
$listservaddr = "listserv$listaddr";

$listbase = '/home/peter/listproc/lists';
$mycat = '/home/peter/listhack/mycat';

# Get the input and strip off all unwanted characters
read(STDIN, $post_args, $ENV{'CONTENT_LENGTH'});

$post_args =~ s/\+/ /g;
$post_args =~ s/%([0-9|A-F]{2})/pack(C,hex($1))/eg;

foreach (split(/&/,$post_args)) {
  ($name, $value) = split(/=/, $_);
  if ($name eq 'email') {
    $email = $value;
  } elsif ($name eq 'list') {
    $list = $value;
  } elsif (! $dowhat) {
    $dowhat = $name;
  } else {
    DoError( "Unknown post argument '$name=$value'" );
  }
}

$email =~ tr/!-~//cd;

DoError( "Missing post argument: email" ) unless defined($email);
DoError( "Missing post argument: list" ) unless $list;
DoError( "Missing post argument: action" ) unless $email;

if ($email !~ /@/) {
  DoRedirect( "/mailinglists/noemail.shtml?$email" );
} elsif ( !IsList() ) {
  DoError( "The $list list does not exist" );
} elsif ($dowhat eq 'subscribe') {
  DoSubscribe();
} elsif (!IsSubscribed()) {
  DoRedirect( "/mailinglists/notsubscribed.shtml?$email" );
} elsif ($dowhat eq 'unsubscribe') {
  DoCommand( "unsubscribe $list" );
} elsif ($dowhat eq 'ack' || $dowhat eq 'noack' ||
      $dowhat eq 'digest' || $dowhat eq 'postpone' ) {
  DoCommand( "set $list mail $dowhat" );
} else {
  DoError( 'What command?' );
}

sub DoCommand {
  local( $command ) = @_;

  sendmail( $email, $listservaddr, 'none', $command );
  DoRedirect( "/mailinglists/processedcmd.html" );
}

sub DoSubscribe {
  sendmail( "$list-on$listaddr", $email, 
    "Reply to subscribe to $list$listaddr",
    <<"EOM" );
Reply to this mail message and you will be subscribed to this list:

$list$listaddr

After you are subscribed, you can send mail to that address to post.

To unsubscribe, send mail to $list-off$listaddr.

You are not subscribed yet - reply to this message to subscribe.
EOM

  DoRedirect( "/mailinglists/processedsub.html" );
}

sub sendmail {
  local($from, $to, $subject, $what) = @_;
  open(MAIL, "|/usr/lib/sendmail -t -f $from") || die;
  print MAIL <<"EOM";
To: $to
From: $from
Subject: $subject

$what
EOM
  close(MAIL);
}

sub DoError {
  local( $message ) = @_;

  print <<"EOM";
Content-type: text/html

<h1>Error: CGI failed</h1>
The CGI failed: $message
<p>
EOM
  exit( 0 );
}

sub DoResponse {
  local( $message ) = @_;

  print <<"EOM";
Content-type: text/html

<HTML>
<HEAD><TITLE>Processed</TITLE></HEAD>
<BODY>
$message
</BODY>
</HTML>
EOM
}

sub DoRedirect {
  local( $url ) = @_;

  print "Location: $url\n\n";
}

sub IsList {
  $LIST = $list;
  $LIST =~ tr/a-z/A-Z/;
  return -e "$listbase/$LIST/.subscribers";
}

sub IsSubscribed {
  local( $LIST, $EMAIL, $result );
  $LIST = $list;
  $LIST =~ tr/a-z/A-Z/;
  $EMAIL = $email;
  $EMAIL =~ tr/a-z/A-Z/;
  $result = 0;
  if ( open( LIST, "$mycat $listbase/$LIST/.subscribers|" ) ) {
    while (<LIST>) {
      chop;
      s/ .*//;
      tr/a-z/A-Z/;
      if ( $_ eq $EMAIL ) {
        $result = 1;
        last;
      }
    }
    close( LIST );
  }
  return $result;
}
